<template>
    <div class="reportQuarantine">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">上报检疫</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getReportList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="inspectionDate" label="送检日期"></el-table-column>
                    <el-table-column prop="inspectionPerson" label="送检人员"></el-table-column>
                    <el-table-column prop="status" label="状态"></el-table-column>
                    <el-table-column prop="quarantineNo" label="检疫单编号"></el-table-column>
                    <el-table-column prop="slaughterBatch" label="屠宰批次"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addReport" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="送检日期">
                            <el-date-picker
                                v-model="formData.inspectionDate"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="送检人员">
                            <el-input v-model="formData.inspectionPerson"></el-input>
                        </el-form-item>

                        <el-form-item label="状态">
                            <el-input v-model="formData.status"></el-input>
                        </el-form-item>

                        <el-form-item label="检疫单编号">
                            <el-input v-model="formData.quarantineNo"></el-input>
                        </el-form-item>

                        <el-form-item label="屠宰批次">
                            <el-select v-model="formData.slaughterBatch" filterable placeholder="请选择">
                                <el-option
                                    v-for="item in $store.state['slaughterBatchIdList']"
                                    :key="item"
                                    :label="item"
                                    :value="item"
                                ></el-option>
                            </el-select>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addReport')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqReportList,
    reqAddReport,
    reqUpdateReport,
    reqDelReport
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "reportQuarantine",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                inspectionDate: this.$moment().format("YYYY-MM-DD"),
                inspectionPerson: "王炸",
                status: "1",
                quarantineNo: "88255662380",
                slaughterBatch: null
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 上报检疫列表
        this.getReportList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddReport(this.formData)
                            .then(res => {
                                // 上报检疫列表
                                this.getReportList();
                                // this.$message.success("添加成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateReport(this.formData)
                            .then(res => {
                                // 上报检疫列表
                                this.getReportList();
                                // this.$message.success("编辑成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 上报检疫列表 
        getReportList() {
            reqReportList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelReport(row.id)
                .then(res => {
                    console.log(res);
                    // 上报检疫列表
                    this.getReportList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 上报检疫列表
            this.getReportList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>